Package: UKFE
Type: Package
Title: UK Flood Estimation
Version: 2.0.2
Authors@R: person(given = "Anthony",
                    family = "Hammond",
                    role = c("aut", "cre"),
                    email = "agqhammond@gmail.com")
Maintainer: Anthony Hammond <agqhammond@gmail.com>
Description: Functions to implement the methods of the Flood Estimation Handbook (FEH), associated updates and the revitalised flood hydrograph model (ReFH). Currently the package uses NRFA peak flow dataset version 14. Aside from FEH functionality, further hydrological functions are available. Most of the methods implemented in this package are described in one or more of the following: "Flood Estimation Handbook", Centre for Ecology & Hydrology (1999, ISBN:0 948540 94 X). "Flood Estimation Handbook Supplementary Report No. 1", Kjeldsen (2007, ISBN:0 903741 15 7). "Regional Frequency Analysis - an approach based on L-moments", Hosking & Wallis (1997, ISBN: 978 0 521 01940 8). "Making better use of local data in flood frequency estimation", Environment Agency (2017, ISBN: 978 1 84911 387 8). "Sampling uncertainty of UK design flood estimation" , Hammond (2021, <doi:10.2166/nh.2021.059>). "The FEH 2025 statistical method update", UK Centre for Ecology and Hydrology (2025). "Low flow estimation in the United Kingdom", Institute of Hydrology (1992, ISBN 0 948540 45 1). Data from the UK National River Flow Archive (<https://nrfa.ceh.ac.uk/>, terms and conditions: <https://nrfa.ceh.ac.uk/help/costs-terms-and-conditions>).
URL: https://agqhammond.github.io/UKFE/,
        https://github.com/agqhammond/UKFE
BugReports: https://github.com/agqhammond/UKFE/issues
License: GPL-3
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.3.2
Depends: R (>= 3.5.0)
VignetteBuilder: knitr
Imports: xml2, methods, sf
Suggests: knitr, rmarkdown
NeedsCompilation: no
Packaged: 2026-06-19 14:02:10 UTC; AnthonyHammond
Author: Anthony Hammond [aut, cre]
Repository: CRAN
Date/Publication: 2026-06-19 14:40:02 UTC
Built: R 4.6.0; ; 2026-06-19 15:43:37 UTC; unix

# Introduction

The primary purpose of the UKFE R package is to implement the regional flood frequency methods outlined by the Flood Estimation Handbook (FEH; available at <https://www.ceh.ac.uk/data/software-models/flood-estimation-handbook>) and associated updates. However, there are numerous other functions of use to the hydrologist.

The UKFE package was initially developed by Anthony Hammond in 2020, and he has been updating it regularly since then with additional functionality and in response to new published methods and changes to best practice. 

In 2025, the Environment Agency commissioned JBA Consulting to undertake testing of the package, to write this documentation and training material and to assess future needs. Changes to the package for v1.0.0 were a result of this testing and funded by the Environment Agency. The package has been updated since to account for changes to the FEH method and for general improvements and bug fixes. The GitHub webpages including vignette guides, function reference, and a change log, can be found here: <https://agqhammond.github.io/UKFE/>. At the time of writing, the training material is out of date. 

# Contents

The 'Changelog' tab summarises updates in each version of the UKFE.

Under 'Articles', there are quick guides to the following topics:

* Basic R concepts and resources (R quick start guide).

* Data inputs. 

*	Data visualisation.

*	FEH statistical analysis.

* ReFH analysis.

*	Troubleshooting common errors.

There is also a 'References' article (under the "Articles" drop down, not the references tab), which contains the references of books, user guides or papers cited throughout the documentation.

There is no assumption that readers of these guides are experienced 'R' users, but there is an assumption of familiarity with the application of the FEH methods. More detailed step-by-step guidance can be found in the training material. There is an introduction to some R concepts that may be useful in the 'R quick start guide' article.

Note that some of the information in the vignettes is based on that of the FloodHydroStats website (<https://www.floodhydrostats.com/ukfe-package-feh-quick-guide>).

# Hints and tips

For more information about the functions discussed in the guides and further functions of the package, all the functions are detailed in the 'References' tab (with links to their help files) and in a PDF under Reference Manual via the following link: <https://CRAN.R-project.org/package=UKFE>

Details can also be viewed in the package documentation within the 'R' environment. To get help with individual functions, you can type `help(FunctionName)` or `?FunctionName`. If using RStudio, you can click on the 'Packages' tab in the bottom right pane (assuming the default layout), search for UKFE, and then click on it. You will then see a list of functions; each can be clicked for more details. To get a list of the function names, type `ls("package:UKFE")`.

Note that for any functions that take file paths, on Windows operating systems, the backslashes will need to be changed to forward slashes, or the file path will need to be stated as follows: `r"{my\file\path}"`.

Many of the examples throughout this documentation have the outputs from running the code displayed below the code.

# Installation guide

It is recommended that the UKFE R package be used in RStudio (an integrated development environment for R). You will first need to install R from <https://cran.r-project.org/> and then RStudio can be downloaded from <https://docs.posit.co/ide/user/#rstudio-ide-oss-downloads>.

Once RStudio is open, the package must be installed and then loaded to access its functions.

Note that installing the package only needs to be done once (although it will need redoing if the UKFE package is updated or if you update your version of R). Once you have installed the package, it will be saved in your package library. 

The package must be loaded from the library at the start of each new R session to make its functions available.

The following commands can be entered into the console to carry out these steps. 

## Install from CRAN 

Install the UKFE package: `install.packages("UKFE")`

## Install from GitHub

First, install the `remotes` package if you do not already have it installed: `install.packages("remotes")`

Then, install UKFE directly from GitHub: `remotes::install_github("agqhammond/UKFE")`

You may be prompted to update package dependencies — choosing option "1: All" is recommended.

## Load the package

Once installed, load it into your R session: `library(UKFE)`

You can also check the installed version with: `packageVersion("UKFE")`

# Data

Acknowledgement: Data from the UK National River Flow Archive.

This package is based on data from the National River Flow Archive (NRFA). There is a pre-processing script that converts new releases of the NRFA Peak Flow Dataset into data frames suitable for use within UKFE.

Note that the unit tests include a small subset of data from the NRFA Peak Flow Dataset, consisting of XML and AM files. This data sample can only be used for test purposes. Please see the NRFA website (<https://nrfa.ceh.ac.uk/>) for station metadata, the download of the full peak flows dataset (<https://nrfa.ceh.ac.uk/data/peak-flow-dataset>), and the data licence (<https://eidc.ceh.ac.uk/licences/nrfa-data-terms-and-conditions-for-api-access-to-time-series-data-and-metadata/>).

# Feedback

If you have any feedback or suggestions, then please contact Anthony Hammond at [floodhydrostats@gmail.com](mailto:floodhydrostats@gmail.com) or contribute to the GitHub discussion page (<https://github.com/agqhammond/UKFE/issues>). You can submit edits and additions to the package through GitHub.

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup--------------------------------------------------------------------
# Load the package
library(UKFE)

## -----------------------------------------------------------------------------


# View the first rows of the data in the console
head(PeakFlowData)

## ----fig.alt="Bar chart of annual maximum river flow. The x-axis shows years, and the y-axis shows peak flow in cubic meters per second. Each bar represents the highest flow in that year. The flows vary from year to year, with several notably high peaks in recent years."----
# Extract the AMAX data for NRFA site 55002 and save to an object called 'AM.55002'
AM.55002 <- GetAM(55002)

# View the head of the AMAX series
head(AM.55002)

# Plot the AMAX data
AMplot(AM.55002)

## -----------------------------------------------------------------------------
# Extract and view catchment descriptors for NRFA gauge 39001
GetCDs(39001)

## -----------------------------------------------------------------------------
# Extract catchment descriptors for NRFA gauge 39001 and store in an object called 
# 'CDs.39001'
CDs.39001 <- GetCDs(39001)

## ----eval = FALSE-------------------------------------------------------------
#  # Extract catchment descriptors from an xml file and store in an object called
#  # 'CDs.MySite'
#  CDs.MySite <- CDsXML("C:/Data/FEH_Catchment_384200_458200.xml")
#  
#  # As above but retaining backslashes in the file path
#  CDs.MySite <- CDsXML(r"{C:\Data\FEH_Catchment_384200_458200.xml}")

## ----eval = FALSE-------------------------------------------------------------
#  # Extract catchment descriptors from an xml file and store in an object called
#  # 'CDs.27003'
#  CDs.27003 <- CDsXML("C:\Data\NRFAPeakFlow_v13-0-2\suitable-for-neither\027003.xml")

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup--------------------------------------------------------------------
library(UKFE)

## ----fig.alt="Runoff hydrograph showing rainfall inputs and resulting flow components. The x-axis shows time in hours. The left y-axis shows discharge, and the right y-axis shows rainfall in millimetres. Rainfall is shown as inverted filled blue bars along the top of the plot, and net rainfall as inverted green striped bars; rainfall is consistently greater than net rainfall, both rising and peaking around 15 hours. Flow is shown as lines: total flow in solid black, baseflow in short dashed green, and direct runoff in dashed red. Total flow and direct runoff peak later than rainfall, with sharp peaks at around 30 hours, while baseflow lags further and peaks more broadly at about 47 hours. The total flow reaches the highest magnitude, followed by direct runoff, with baseflow peaking at much lower levels in a flatter, wider shape."----
# Obtain catchment descriptors for NRFA gauge 55002
CDs.55002 <- GetCDs(55002)

# Obtain outputs of the ReFH model from catchment descriptors for a default 2-year 
# rainfall event
ReFHResult55002 <- ReFH(CDs.55002)
# print to console
ReFHResult55002

## -----------------------------------------------------------------------------
# Create an ungauged pooling group for site 55002 
PoolUG.55002 <- Pool(CDs.55002, exclude = 55002)

# Estimate QMED for site 55002 using catchment descriptors and two donor gauges
CDsQmed.55002 <- QMED(CDs.55002, DonorIDs = c(55007, 55016))

# Estimate design flows using the above pooling group and QMED
Results55002 <- PoolEst(PoolUG.55002, QMED = CDsQmed.55002, CDs = CDs.55002)

## ----fig.alt="Design hydrograph scaled to the estimated peak flow, illustrating the typical storm response. The x-axis is an index of time steps (hours in this case). The hydrograph follows the classic shape, rising steeply to a peak at about 32 hours, then receding more gradually with an elongated, tapering descent. This provides a standardised representation of flow behaviour during a peak event."----
# Extract the 100-year flow estimate (the [[1]] denotes the first element of the list - which is a dataframe, then [8,2] is the 8th row and 2nd column of that dataframe)
Q100.55002 <- Results55002[[1]][8, 2]

# Obtain the final flow outputs of the ReFH model from catchment descriptors for a default 2-year 
# rainfall
TotalFlow <- ReFHResult55002[[2]]$TotalFlow

#Scale this by dividing by the maximum of the flow
ScaledFlow <- TotalFlow / max(TotalFlow)

#Multiply the scaled flow by our peak flow estimate and plot
plot(ScaledFlow * Q100.55002, type = "l", lwd = 2, ylab = "Discharge (m3/s)", xlab = "Time (hours)")


## ----eval = FALSE-------------------------------------------------------------
#  # Save the ReFH design hydrograph to an object called 'DesignHydro55002'.
#  DesignHydro55002 <- ScaledFlow * Q100.55002
#  
#  # Write to csv
#  write.csv(DesignHydro55002, "my/file/path/DesHydro55002.csv", row.names = FALSE)
#  

## ----fig.alt="ReFH output with settings adjusted to result in the FSR/FEH rainfall runoff model. The baseflow is constant and the shape is less elongated than the default ReFH output which uses a kinked triangle unit hydrograph. The rainfall profile is randomised but centrally loaded."----
ReFH.FSR <- ReFH(CDs.55002, RainProfile = "Centre", UHShape = "FSR", Loss = 0.3, BR = 0)

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup--------------------------------------------------------------------
library(UKFE)

## ----fig.alt="Bar chart of annual maximum (AMAX) flow values. Each bar represents the highest recorded flow in a given year, with year index on the x-axis and flow magnitude on the y-axis. The chart shows variation across years, with particularly large peaks in 1980, 1999, and 2020."----

# Get an AMAX sample and plot
AMplot(GetAM(58002))

## ----fig.alt="Time series plot of flow showing extraction of peaks over threshold events. The x-axis shows time and the y-axis shows flow magnitude. Red circles mark exceedances above the blue threshold line. A green line indicates div, which defines independence between peaks; in this case it is set to the mean. Exceedances occur throughout the record, with a lull around 2005, followed by a marked increase in frequency afterwards."----
# Extract POT flows for the Thames at Kingston (NRFA gauge 39001) and plot. Note that 
# the indexing 'ThamesPQ[, c(1, 3)]' is necessary because the date is in the first 
# column of the 'ThamesPQ' data frame and the flow is in the third.
ThamesQPOT <- POTextract(ThamesPQ[, c(1, 3)], thresh = 0.9, Plot = TRUE)

## ----fig.alt="Plot showing extraction of peaks over threshold (POT) events from a rainfall time series. The x-axis shows time and the y-axis shows flow magnitude. Red circles mark rainfall values exceeding the blue threshold line, which identifies independent extreme events. Exceedances occur throughout, with particularly large peaks around 2000, 2007, and 2014."----

# Extract POT rainfall for the Thames at Kingston (NRFA gauge 39001) and plot. Note that
# the indexing 'ThamesPQ[, 1:2]' is necessary because the date is in the first column 
# of the 'ThamesPQ' data frame and the rainfall is in the second.
ThamesPPOT <- POTt(ThamesPQ[, 1:2], threshold = 0.95, div = 14, Plot = TRUE)

## ----fig.alt="“Time series plot showing precipitation and river discharge together. The x-axis shows time. River discharge is shown as a line with flow values on the left y-axis, while precipitation is displayed as inverted bars with rainfall on the right y-axis. This allows comparison of rainfall events with resulting river flows. A sustained period of elevated rainfall and associated discharge is evident from December 2013 through to March 2014.”"----
# Plot the 2013 water year precipitation and discharge for the Thames at Kingston 
# (NRFA gauge 39001), adjusting the closeness of the precipitation and discharge 
# on the y-axis to 1.8.
HydroPlot(ThamesPQ, From = "2013-10-01", To = "2014-09-30", adj.y = 1.8)

## ----fig.alt="Bar plot showing mean river discharge for each calendar month, with the x-axis representing months and mean flow values on the y-axis. Flows are highest in winter, with January showing the maximum, and lowest in late summer, with September showing the minimum. As expected. Discharge is elevated from November through March, and decreases gradually into summer before rising again into autumn."----
# Calculate the mean flows for each month for the Thames at Kingston (NRFA gauge 39001)
# and set the plot title using the 'main' argument
QMonThames <- MonthlyStats(ThamesPQ[, c(1, 3)], Stat = mean, ylab = "Discharge (m3/s)", 
                           main = "Thames at Kingston monthly mean flow", Plot = TRUE)

## ----fig.alt="Bar plot showing the mean total rainfall for each calendar month. The x-axis shows months and the y-axis shows rainfall totals, allowing comparison of rainfall patterns across the year. Rainfall is relatively high throughout, with a clear minimum in September and a maximum in November. The wettest period extends from October through January."----
# Calculate the monthly sums of rainfall for the Thames at Kingston and set the plot 
# title using the 'main' argument
PMonThames <- MonthlyStats(ThamesPQ[, c(1, 2)], Stat = sum, ylab = "Rainfall (mm)", 
                           main = "Thames at Kingston monthly rainfall", Plot = TRUE)

## ----fig.alt="Line plot showing river discharge over time. The x-axis shows time in days and the y-axis shows daily mean flow. Total flow is shown in black, and baseflow is shown in red. Flows are relatively constant overall, with peaks occurring at fairly regular intervals. Baseflow rises and falls with total flow, but remains lower in magnitude."----
# Calculate the BFI from daily discharge at Kingston upon Thames (which is in the 
# third column of the 'ThamesPQ' data)
BFI(ThamesPQ[, 3])

## ----fig.alt="Time series plot of streamflow and baseflow. The x-axis shows time and the y-axis shows flow. Total flow is shown in black, and baseflow is shown in red. During events, total flow increases sharply, whereas baseflow rises more gradually and remains much lower in magnitude, highlighting the contrast between quick flow responses and the slower baseflow contribution."----
# Extract a wet six-month period at the Thames at Kingston (NRFA gauge 39001) during 
# the 2006-2007 water year (flow is in the third column of ThamesPQ)
ThamesQ <- subset(ThamesPQ[, c(1, 3)], Date >= "2006-11-04" & Date <= "2007-05-06")
# Apply the flow split with default settings
QSplit <- FlowSplit(ThamesQ$Q)

## ----fig.alt="Time series plot showing a black line representing the averaged design hydrograph, derived by aligning individual hydrographs on their peak flow and then averaging. The observed hydrographs are shown as coloured and patterned lines. The x-axis represents time and the y-axis shows scaled discharge. The individual hydrographs vary considerably: some display additional smaller peaks around the main one, while others differ in steepness and shape. In general, hydrographs with higher pre-peak discharge also exhibit higher post-peak discharge. All converge at the peak, and the overall mean hydrograph follows the typical triangular, inverted-V shape."----
# Extract a design hydrograph from the Thames at Kingston (NRFA gauge 39001) daily 
# mean flow and print the resulting hydrograph
ThamesDesHydro <- DesHydro(ThamesPQ[, c(1, 3)], EventSep = 10, N = 10)

## ----fig.alt="Plot showing flow duration curves for a single flow series with seasonal variations. The x-axis shows the percentage of time flow is exceeded, and the y-axis shows discharge. The annual curve is shown as a black line, the winter curve as a blue line, and the summer curve as a green line. Winter flows are consistently highest, followed by annual, then summer. All curves follow the expected pattern of high discharges at low exceedance percentages and progressively lower discharges as exceedance percentages increase."----
# Plot a flow duration curve for the Thames at Kingston (NRFA gauge 39001) using 
# data from Oct 2000 to Sep 2015
FlowDurationCurve(ThamesPQ[, c(1, 3)])

## ----fig.alt="Plot showing the relationship between discharge (x-axis) and stage (y-axis). Observed measurements are shown as open circles with black borders, and a red line represents the optimised power law rating equation fitted to these observations. For this dataset, stage and discharge exhibit an almost linear relationship, with the fitted curve close to straight but showing a very gradual downward concavity while remaining continuously increasing."----
# Make up some flow (Q) and stage data to act as gaugings
Q <- c(177.685, 240.898, 221.954, 205.55, 383.051, 154.061, 216.582)
Stage <- c(1.855, 2.109, 2.037, 1.972, 2.574, 1.748, 2.016)
Observations <- data.frame(Q, Stage)

# Apply the rating function
Rating(Observations)

## ----fig.alt="Depth–Duration–Frequency (DDF) plot showing rainfall depth in millimetres (y-axis) as a function of storm duration in hours (x-axis) for a range of return periods. Each curve represents a different return period. All curves follow the characteristic DDF shape, with rainfall depth increasing as event rarity increases and with longer storm durations, particularly at the longer return periods."----
# Extract 15-minute rainfall from the St Ives (Cambridgeshire) rain gauge
StIves <- tryCatch(
  GetDataEA_Rain(WISKI_ID = "179365", Period = "15Mins", From = "2022-01-01", To = "2025-01-31"),
  error = function(e) NULL
)


if (!is.null(StIves) && nrow(StIves) > 0) {
  DDFExtract(StIves)
} else {
  message("Environment Agency API did not return data; skipping plot generation.")
}

#Data update version 13.0.2

library(UKFE)
library(xml2)

OrigWD <- getwd()

#

WD <- "D:/NRFAPeakFlow_v13-0-2/"
setwd(WD)
PoolingWD <- paste(WD, "suitable-for-pooling/", sep = "")
QMEDwd <- paste(WD, "suitable-for-both/", sep = "")

AMFiles <- list.files(path = PoolingWD, pattern = ".am")
setwd(PoolingWD)
AMs <- list()
for(i in 1:length(AMFiles)) {AMs[[i]] <- AMImport(AMFiles[i])}
AMFilesSplit <- strsplit(AMFiles, split = ".am")
id <- NULL
for(i in 1:length(AMs)) {id[i] <- as.character(as.numeric(AMFilesSplit[[i]]))}
#AMs[[1]] <- data.frame(AMs[[1]], rep(id[1], nrow(AMs[[1]])))
for(i in 1:length(AMs)) {AMs[[i]] <- data.frame(AMs[[i]], rep(id[i], nrow(AMs[[i]])))}
for(i in 1:length(AMs)) {colnames(AMs[[i]])[3] <- "id"}
AMSPComp <- rbind(AMs[[1]], AMs[[2]])
for(i in 3:length(AMs)) {AMSPComp <- rbind(AMSPComp, AMs[[i]])}
LStats <- rbind(Lmoms(AMs[[1]][,2])[c(5, 6, 7, 1, 2)], Lmoms(AMs[[2]][,2])[c(5, 6, 7, 1, 2)])
for(i in 3:length(AMs)) {LStats <- rbind(LStats, Lmoms(AMs[[i]][,2])[c(5, 6, 7, 1, 2)])}

setwd(QMEDwd)
XMLFiles <- list.files(path = QMEDwd, pattern = ".xml")
XMLFilesSplit <- strsplit(XMLFiles, split = ".xml")
RwNames <- NULL
for(i in 1:length(XMLFiles)) {RwNames[i] <- as.character(as.numeric(XMLFilesSplit[[i]]))}
CDsList <- list()
for(i in 1:length(XMLFiles)) {CDsList[[i]] <- CDsXML(XMLFiles[i])}
CDsDF <- rbind(CDsList[[1]][,2], CDsList[[2]][,2])
for(i in 3:length(XMLFiles)) {CDsDF <- rbind(CDsDF, CDsList[[i]][,2])}
colnames(CDsDF) <- CDsList[[1]][,1]
rownames(CDsDF) <- RwNames
CDsDF <- as.data.frame(CDsDF)
AMqmedFiles <- list.files(pattern = ".am")
QMEDs <- NULL
for(i in 1:length(AMqmedFiles)) {QMEDs[i] <- median(AMImport(AMqmedFiles[i])[,2])}
QMEDcd <- NULL
for(i in 1:length(CDsList)) {QMEDcd[i] <- QMED(CDsList[[i]])}
QMEDfse <- NULL
for(i in 1:length(AMqmedFiles)) {QMEDfse[i] <- QMEDfseSS(AMImport(AMqmedFiles[i])[,2])}
N <- NULL
for(i in 1:length(AMqmedFiles)) {N[i] <- nrow(AMImport(AMqmedFiles[i]))}
CDsDF <- cbind(CDsDF, QMEDs, QMEDcd, QMEDfse, N)
colnames(CDsDF)[which(colnames(CDsDF) == "QMEDs")] <- "QMED"

MatchSS <- match(id, rownames(CDsDF))
SuitsPool <- CDsDF[MatchSS,]
SuitsPool <- cbind(SuitsPool, LStats)
SPTrunc <- SuitsPool[,c(seq(1,20), 23, 27, 28, 29, 30, 31, 26)]
colnames(SPTrunc)[21] <- "QMED"

#Read in NI grid Refs
IreInd <- which(as.numeric(rownames(SPTrunc)) > 200000)
NIRefs <- read.csv("C:/Users/anthonyhammond/OneDrive - JBA Group/UKFE/NISiteGridRefs.csv", colClasses = c("character", "numeric", "numeric"))
MatchIDs <- match(rownames(SPTrunc)[IreInd], NIRefs$ID)
NIUse <- NIRefs[MatchIDs,]
SPTrunc[IreInd,19:20] <- NIUse[,2:3]


NRFAData <- SPTrunc

#this is to adjust site 44003 which is identical to 44011 - which causes problems
Ind44003 <- which(rownames(NRFAData) == 44003)
NRFAData$AREA[Ind44003] <- 49.1
NRFAData$Easting[Ind44003] <- NRFAData$Easting[Ind44003]+1

save(NRFAData, file = "C:/Users/anthonyhammond/OneDrive - JBA Group/Documents/UKFE/data/NRFAData.rda")

QMEDDF <- CDsDF[,c(seq(1,18), 23, 24, 19, 20, 25, 26, 21, 22)]
colnames(QMEDDF)[21:22] <- c("X", "Y")
colnames(QMEDData)[19] <- "QMED"

IreInd <- which(as.numeric(rownames(QMEDDF)) > 200000)
MatchIDs <- match(rownames(QMEDDF)[IreInd], NIRefs$ID)
NIUse <- NIRefs[MatchIDs,]
QMEDDF[IreInd,21:22] <- NIUse[,2:3]

QMEDData <- QMEDDF

#this is to adjust site 44003 which is identical to 44011 - which causes problems
Ind44003 <- which(rownames(QMEDData) == 44003)
QMEDData$AREA[Ind44003] <- 49.1
QMEDData$X[Ind44003] <- QMEDData$X[Ind44003]+1

save(QMEDData, file = "C:/Users/anthonyhammond/OneDrive - JBA Group/Documents/UKFE/data/QMEDData.rda")

AMSP <- AMSPComp
save(AMSP, file = "C:/Users/anthonyhammond/OneDrive - JBA Group/Documents/UKFE/data/AMSP.rda")

setwd(OrigWD)

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----echo = FALSE, results = 'asis'-------------------------------------------
library(knitr)
kable(data.frame(Function = c("GetCDs/CDsXML", "GetAM/AMImport", "QuickResults", "QMED", "DonAdj", "Pool", "H2", "DiagPlots", "Zdists", "PoolEst", "Uncertainty", "GenLog/GEV/GenPareto/Gumbel/Kappa3", "POTextract or POTt", "AnnualStat"), Purpose = c("Get catchment descriptors using the NRFA gauge reference number or import them from XML files downloaded from the FEH Web Service", "Get annual maximum data from sites suitable for pooling or from AM files", "Provides default pooling results (gauged, ungauged & fake ungauged), directly from catchment descriptors", "Estimates QMED from catchment descriptors with donor options (either donor IDs or a number of donors - which are then automatically chosen based on distance)", "Provides a list of donor candidates based on proximity to the study catchment", "Creates a pooling group with the option of excluding one or more sites", "The heterogeneity measure for pooling groups", "Provides a number of diagnostic plots to compare the sites in a pooling group", "The Zdist statistic to determine the distribution with the best fit to the pooling group", "Flood estimates from the pooling group", "Quantifies uncertainty for gauged (enhanced single-site) and ungauged pooling groups", "Four functions for each distribution to fit the distribution and obtain flood frequency estimates and growth factors", "Functions for extracting peaks over threshold data", "Extract annual statistics. The default is maximum, but any statistic can be used such as sum or mean.")))

## ----setup--------------------------------------------------------------------
library(UKFE)

## -----------------------------------------------------------------------------
# Get catchment descriptors for NRFA site 55002 and save to an object called CDs.55002
CDs.55002 <- GetCDs(55002)

# Obtain estimates and plots for the gauged scenario using default settings
QuickResults(CDs.55002)

## -----------------------------------------------------------------------------
# Estimate QMED from the catchment descriptors for site 55002
QMED(CDs.55002)

## -----------------------------------------------------------------------------
# Identify donor catchments based on the catchment descriptors for site 55002
DonAdj(CDs.55002)

## -----------------------------------------------------------------------------
# Estimate QMED from the catchment descriptors for site 55002 using gauges with NRFA
# IDs 55007 and 55016 as donor sites
QMED(CDs.55002, DonorIDs = c(55007, 55016, 55013))

# Use the closest three donor sites
QMED(CDs.55002, no.Donors = 3)

#Use the specified three donors and return the associated details of the adjustment
QMED(CDs.55002, DonorIDs = c(55007, 55016, 55013), ReturnDetails = TRUE)


## -----------------------------------------------------------------------------
# Create a pooling group based on the catchment descriptors for site 55002 and 
# save to an object called Pool.55002
Pool.55002 <- Pool(CDs = CDs.55002)

# View the pooling group
Pool.55002

## ----echo = FALSE-------------------------------------------------------------
set.seed(5)

## -----------------------------------------------------------------------------
# Check for heterogeneity
H2(Pool.55002)

## ----fig.alt="Diagnostic plot consisting of 10 panels used to aid review of catchment descriptors. The first seven panels show histograms of all catchments, with each of the ten sites marked by small crosses, for the following variables: Area, SAAR, PROPWET, FARL, FPEXT, BFIHOST19, and URBEXT2000. Two scatter plots display L-skew versus L-CV and L-skew versus L-kurtosis. The next panel shows the catchment locations as points on a UK outline, plotted by Eastings and Northings. The final panel shows the average seasonality of peaks for all the sites in the pooling group. Together, the plots allow comparison of these sites against the distribution of all catchments. The ten sites appear generally central and unremarkable across descriptor space, indicating they are fairly typical relative to the wider catchment set."----
# Create diagnostic plots to aid review of the pooling group
DiagPlots(Pool.55002)

## -----------------------------------------------------------------------------
# Recreate the pooling group, excluding NRFA sites 8010 and 76017
Pool.55002 <- Pool(CDs = CDs.55002, exclude = c(8010, 76017))

# View the new pooling group
Pool.55002

# Check for heterogeneity
H2(Pool.55002)

## -----------------------------------------------------------------------------
# Calculate goodness-of-fit measure
Zdists(Pool.55002)

## ----eval = FALSE-------------------------------------------------------------
#  MyData <- scan()

## -----------------------------------------------------------------------------
# Update the pooling group to use user-supplied L-CV and L-skew values for site 55002
UpdatedPool <- LRatioChange(Pool.55002, SiteID = 55002, lcv = 0.187, lskew = 0.164)

# View the updated pooling group
UpdatedPool

## -----------------------------------------------------------------------------
# Extract QMED from the QMEDdata data frame within the UKFE package
GetQMED(55002)

## -----------------------------------------------------------------------------
# Derive the growth curve and final flow estimates based on the pooling group and QMED
PoolEst(Pool.55002, CDs = CDs.55002, QMED = GetQMED(55002), Gauged = TRUE)

## ----fig.alt="Plot showing growth curves from FEH QuickResults calculations. Pooled estimates are shown as a solid line, single-site estimates as a dashed green line, and observed flood data as blue circles. The x-axis shows the logistic reduced variate and the y-axis shows Q/QMED, that is, flow divided by the median annual flood. A scale for the return period is displayed at the bottom right. The plot illustrates how well the pooled and single-site growth curves map onto the observed flood data. Neither curve matches all observations exactly, but both provide a reasonable fit overall. Both curves follow the expected growth-curve shape, with increasing discharge at higher return periods."----
# Plot the growth curve
EVPool(Pool.55002, gauged = TRUE)

## ----fig.alt="Plot showing how multiple single-site growth curves are pooled to form the default ‘fake ungauged’ growth curve. The x-axis shows the logistic reduced variate and the y-axis shows Q/QMED, that is, flow divided by the median annual flood. Several solid black lines represent growth curves from individual sites, and a red dashed line represents the pooled growth curve with the target site excluded. All curves follow the expected growth-curve shape, with increasing discharge at higher return periods. The pooled curve lies within the spread of the individual site curves and, as expected, closely resembles their average, illustrating how pooling smooths variability to produce a representative ungauged growth curve."----
# Recreate the pooling group, excluding NRFA gauge 55002 to make it an ungauged analysis
PoolUG.55002 <- Pool(CDs.55002, exclude = 55002)

# View the new pooling group
PoolUG.55002

# Estimate QMED from the catchment descriptors with two donors (note that the QMED 
# value needs to be extracted using `$QMEDs.adj` as there are three elements to the 
# output when two donors are used and the PoolEst function expects just the QMED value)
CDsQmed.55002 <- QMED(CDs.55002, DonorIDs = c(55007, 55016))

# Use the pooling group and the ungauged QMED estimate to provide the pooled estimates
Results55002 <- PoolEst(PoolUG.55002, QMED = CDsQmed.55002, CDs = CDs.55002)

# Print the results
Results55002

# Plot a growth curve for the pooling group
EVPool(PoolUG.55002)

## ----eval = FALSE-------------------------------------------------------------
#  GenLogAM(MyAMAX, RP = 75)

## ----fig.alt="Bar chart of annual maximum river flow. The x-axis shows years, and the y-axis shows peak flow in cubic meters per second. Each bar represents the highest flow in that year. The flows vary from year to year, with several notably high peaks in recent years."----
# Extract the AMAX data for NRFA site 55002
AM.55002 <- GetAM(55002)

# View the head of the AMAX series
head(AM.55002)

# Plot the AMAX data
AMplot(AM.55002)

## ----fig.alt="Extreme rank frequency curve illustrating uncertainty around the estimated growth curve. The x-axis shows the rank and the y-axis shows the percent difference. Observed data are shown as blue circles, plotting along the 0% line. The central modelled curve, shown as a solid line, tracks closely to the observations, while dashed lines represent the 90% bootstrapped confidence interval. The uncertainty bounds remain narrow through the central portion of the curve and expand slightly toward the lower and upper ranks."----
# Generate an extreme rank plot for the AMAX data for NRFA site 55002 and the GEV 
# distribution and set a user-defined title (using the 'main' argument)
ERPlot(AM.55002$Flow, dist = "GEV", main = "Extreme rank plot for NRFA site 55002: GEV")

## ----fig.alt="Extreme rank frequency curve illustrating uncertainty around the estimated growth curve. The x-axis shows the logistic reduced variate and the y-axis shows Q/QMED, that is, flow divided by the median annual flood. Observed data are shown as blue circles, forming a concave-up increasing curve. The central modelled estimate, shown as a solid line, tracks these observations closely. Dashed lines represent the 90% bootstrapped confidence interval, which remains tight across the centre of the distribution and widens toward the extremes."----
# Generate an extreme value plot for the AMAX data for NRFA site 55002 and the GEV
# distribution and set a user-defined title (using the 'Title' argument)
EVPlot(AM.55002$Flow, dist = "GEV", Title = "Extreme value plot for NRFA site 55002: GEV")

## -----------------------------------------------------------------------------
# Estimate the 100-year flow directly from the AMAX data for NRFA site 55002 using
# the GEV distribution
GEVAM(AM.55002$Flow, RP = 100)

# Estimate the return period of the maximum observed flow directly from the AMAX 
# data using the GEV distribution
GEVAM(AM.55002$Flow, q = max(AM.55002$Flow))

## -----------------------------------------------------------------------------
# Estimate the parameters of the GEV distribution from the AMAX data for NRFA site 55002
GEVPars55002 <- GEVPars(AM.55002$Flow)

# View the parameters
GEVPars55002

# Estimate the 75-year flow using these GEV parameters 
GEVEst(loc = GEVPars55002$Loc, scale = GEVPars55002$Scale, shape = GEVPars55002$Shape, RP = 75)

## -----------------------------------------------------------------------------
# Estimate the 75-year GEV growth factor from the L-moments for the AMAX data for 
# NRFA site 55002
GEVGF(lcv = Lcv(AM.55002$Flow), lskew= LSkew(AM.55002$Flow), RP = 75)

## -----------------------------------------------------------------------------
# Estimate the 75-year flow by multiplying the growth factor by the median AMAX flow
GEVGF(lcv = Lcv(AM.55002$Flow), lskew= LSkew(AM.55002$Flow), RP = 75) * median(AM.55002$Flow)

## ----fig.alt="Time series plot of flow showing extraction of peaks over threshold events. The x-axis shows time and the y-axis shows flow magnitude. Red circles mark exceedances above the blue threshold line. A green line indicates div, which defines independence between peaks; in this case it is set to the mean. Exceedances occur throughout the record, with a lull around 2005, followed by a marked increase in frequency afterwards."----
# Extract a POT series from the Thames at Kingston daily mean flow data, selecting 
# the first and third columns from the ThamesPQ data frame which contain the date 
# and flow data respectively. The threshold is set as the 90th percentile.
POT.Thames <- POTextract(ThamesPQ[, c(1, 3)], thresh = 0.9)

# View the output
POT.Thames

## -----------------------------------------------------------------------------
# Estimate the 100-year flow for the Thames at Kingston using the extracted POT series 
GenParetoPOT(POT.Thames$peak, ppy = 1.867, RP = 100)

## -----------------------------------------------------------------------------
# Extract the AMAX for NRFA site 55002
AM.55002 <- GetAM(55002)

## -----------------------------------------------------------------------------
# Estimate uncertainty for the GEV-estimated 100-year flow
Bootstrap(AM.55002$Flow, Stat = GEVAM, RP = 100)

## -----------------------------------------------------------------------------
# Estimate QMED for site 55002 from catchment descriptors using two donors
QMEDEst <- QMED(CDs.55002, DonorIDs = c(55007, 55016))

# Create an ungauged pooling group for site 55002
PoolUG.55002 <- Pool(CDs.55002, exclude = 55002)

# Estimate the uncertainty of the pooling results 
Uncertainty(PoolUG.55002, QMEDEstimate = QMEDEst)

## -----------------------------------------------------------------------------
# Create a gauged pooling group for site 55002
Pool.55002 <- Pool(CDs = CDs.55002, exclude = c(8010, 76017))

# Estimate the uncertainty of the pooling results 
Uncertainty(Pool.55002, Gauged = TRUE)

## ----eval = FALSE-------------------------------------------------------------
#  # Save the peak flow estimates to an object called 'Results.55002'
#  Results.55002 <- PoolEst(PoolUG.55002, QMED = CDsQmed.55002)[[1]]
#  
#  # Write to csv
#  write.csv(Results.55002, "my/file/path/Results55002.csv", row.names = FALSE)

---
title: "R quick start guide"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{R quick start guide}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

This article introduces some basic R concepts that may help when using the UKFE package as well as links to other R resources.

# R basics

## Numerical operations  
In R, we can perform arithmetic operations, for example, try typing the following in the console:

```{r}
1 + 2
3 - 5
4 * 2
6 / 3
```

## Objects
An object acts as a container for storing data. For example, you can assign some text (called a string) to the object called `greeting`:
```{r}
greeting <- "Hello!"
```

You can then use this variable later: 
```{r}
greeting
```

Numbers can be stored in numeric variables:
```{r}
number <- 1
```

These can then be used in arithmetic operations: 
```{r}
number + 10
```

## Vectors 
Vectors are one-dimensional arrays that store data. Each element has the same data type. To create one, you can use the `c` function, which stands for `combine` or `concatenate`. UKFE uses lots of numeric vectors. 
```{r}
vec <- c(1, 2, 3, 4)
```

You can perform calculations with vectors:
```{r}
a <- c(1, 2, 3)
b <- c(4, 5, 6)
a + b
```

```{r}
a <- c(1, 2, 3)
a * 2
```

## Data frames
Data frames are structures made up of rows and columns, similar to the structure of a csv file. Each column in a data frame is a vector. 

``` {r}
column_1 <- c(1, 2, 3, 4)
column_2 <- c(4, 3, 2, 1)

df <- data.frame(column_1, column_2)
head(df)
```

## Functions
R contains some built-in functions. For example, we can use the `mean()` function to find the mean of a vector: 
```{r}
mean(c(1, 2, 3))
```

We can also use a variable inside a function:
```{r}
vector_of_numbers <- c(2, 4, 6)
mean(vector_of_numbers)
```

You can learn about the functions in the UKFE package using this documentation and the functions' help files.

# Learning resources for R

If you are finding the UKFE documentation difficult to follow, or if you would like to further develop your knowledge of R, there are many resources available to help. The following suggestions are particularly useful for those who are new to R or programming in general.

## Online books

- [**R for Data Science**](https://r4ds.hadley.nz/) and [**R Programming for Data Science**](https://bookdown.org/rdpeng/rprogdatascience/) are introductory texts, freely available online. They cover the essentials of working with R, including practical examples and exercises.  
- Both books include lists of additional resources in their 'R Resources' sections.

## Interactive courses

- [**DataCamp**](https://www.datacamp.com) offers interactive, browser-based courses in R. Some introductory content is available for free.

## Webinars and video tutorials

- [**Posit Webinars**](https://posit.co/videos) feature recorded sessions on a wide range of topics, from beginner to advanced level.
- **YouTube** also hosts many high-quality R tutorials and lecture series. Searching for “R programming for beginners” will return playlists of relevant material.  
- **Coursera** offers structured R courses from universities such as Johns Hopkins and the University of Washington. These courses are suitable for beginners and are sometimes available for free or with financial aid.

## Blogs and tutorials

- [**R-bloggers**](https://www.r-bloggers.com) contains tutorials and articles from across the R community. Posts range from beginner-friendly guides to advanced techniques, and often include worked examples and practical applications.

## Support and questions

- If you have questions specifically about this package, you may find it helpful to visit the [**GitHub Discussions**](https://github.com/agqhammond/UKFE/discussions) forum associated with the repository. This is a good place to ask questions, report issues, or see if others have encountered similar problems.

---
title: "Data input"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Data input}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Data within the UKFE package

The UKFE package includes several datasets that can be used used in analyses. These are based on data from the National River Flow Archive (NRFA). There is a pre-processing script that converts new releases of the NRFA Peak Flow Dataset into data frames suitable for use within UKFE (this can be found in the 'inst' folder of the package). UKFE is updated shortly after each release to use the latest data. The user can also input their own data.

The UKFE package contains five datasets. These are:

* `AMPF`: This contains annual maximum data from the NRFA for sites suitable for pooling and QMED. These are from the AM files with years classed as rejected removed. This is a data frame with three columns containing the date, annual maximum peak flow and the NRFA gauge ID.

* `PeakFlowData`: This contains catchment descriptors from the NRFA and calculated statistics for sites suitable for pooling and QMED. The statistics include L-moments, L-moment ratios, sample size and QMED, all derived from the AMAX data with rejected years removed. It is possible for the user to temporarily edit this data frame.

* `ThamesPQ`: This contains daily flow and catchment rainfall for the Thames at Kingston catchment from 2000-10-01 to 2015-09-30. There are three columns containing date (`Date`), precipitation (`P`) and daily mean flow (`Q`). Dates are in the format YYYY-MM-DD, following the ISO 8601 international standard. The data are from the NRFA (gauge 39001).

* `UKOutline`: This contains the eastings and northings around the coastline of the UK. The data are sourced from https://environment.data.gov.uk/.

These datasets each have a help file and can be viewed by typing the name of the dataset into the console, or can be saved to an object to view:

```{r setup}
# Load the package
library(UKFE)
```

```{r}


# View the first rows of the data in the console
head(PeakFlowData)
```

The user can also supply their own data for use in analyses using the AddGauge function. This adds a gauge to the PeakFlowData dataframe for use in the pooling analysis.

# Functions within the UKFE package for importing data

There are a range of functions for importing data, as set out in this section.

## Annual maximum data

An annual maximum series can be obtained for sites suitable for pooling or QMED using the `GetAM()` function. This extracts data from the embedded `AMPF` data frame within the UKFE package. For other AMAX series available from the NRFA Peak Flow Dataset, the `AMImport()` function can be used, as can the `GetDataNRFA()` function (with `Type = "AMAX"`). The former function imports the data from the AM files and excludes the years classed as rejected. The latter function extracts the AMAX using the NRFA API. If you have a flow time series, the `AnnualStat()` function can be used to extract the water year AMAX (or any other annual statistic of interest). The following example uses the `GetAM()` option. 

```{r fig.alt="Bar chart of annual maximum river flow. The x-axis shows years, and the y-axis shows peak flow in cubic meters per second. Each bar represents the highest flow in that year. The flows vary from year to year, with several notably high peaks in recent years."}
# Extract the AMAX data for NRFA site 55002 and save to an object called 'AM.55002'
AM.55002 <- GetAM(55002)

# View the head of the AMAX series
head(AM.55002)

# Plot the AMAX data
AMplot(AM.55002)
```

The `AMplot()` function returns a time series bar plot of the AMAX series.

## Catchment descriptors

Catchment descriptors (CDs) from the NRFA can be brought into the 'R' environment using the `GetCDs()` function. For gauged sites that are suitable for pooling or QMED, these are extracted from the `PeakFlowData` data frame, otherwise, they are extracted using the NRFA API. Note that if they are brought in from the NRFA API (when not suitable for QMED or pooling), some of the descriptors differ; for example, the gauge location is provided rather than the catchment centroid. There will be a warning message when this happens. An example of using the `GetCDs()` function to view the catchment descriptors for the gauge with an NRFA ID of 39001 is as follows:

```{r}
# Extract and view catchment descriptors for NRFA gauge 39001
GetCDs(39001)
```

It's useful to store them as an 'object' for use with other functions, in which case you can give them a name. You can assign the data to the named object using `<-`. For example:
```{r}
# Extract catchment descriptors for NRFA gauge 39001 and store in an object called 
# 'CDs.39001'
CDs.39001 <- GetCDs(39001)
```

Then, when you wish to view them, the object name `CDs.39001` can be entered into the console.

If you wish to derive CDs from an XML file (typically from UKCEH FEH webservice or the NRFA peak flows dataset) for catchments that aren't suitable for pooling or QMED, or are not gauged at all, you can use the `CDsXML()` function. The file path will need to be used. For Windows operating systems, the backslashes will need to be changed to forward slashes, or the file path will need to be stated as follows: `r"{my\file\path}"`. For example, you can import some descriptors downloaded from the FEH Web Service as follows:
```{r, eval = FALSE}
# Extract catchment descriptors from an xml file and store in an object called 
# 'CDs.MySite'
CDs.MySite <- CDsXML("C:/Data/FEH_Catchment_384200_458200.xml")

# As above but retaining backslashes in the file path
CDs.MySite <- CDsXML(r"{C:\Data\FEH_Catchment_384200_458200.xml}")
```

Or if importing CDs from the NRFA Peak Flow Dataset:
```{r, eval = FALSE}
# Extract catchment descriptors from an xml file and store in an object called 
# 'CDs.27003'
CDs.27003 <- CDsXML("C:\Data\NRFAPeakFlow_v13-0-2\suitable-for-neither\027003.xml")
```

## Other hydrological data retrieval functions using APIs

There are several functions with names starting with `GetData` that extract data from the websites of different organisations using their APIs. These are: 

* `GetDataEA_QH()`: Extracts flow or level data from the Environment Agency's Hydrology Data Explorer.

* `GetDataEA_Rain()`: Extracts rainfall data from the Environment Agency's Hydrology Data Explorer.

* `GetDataMetOffice()`: Extracts regional mean (monthly, seasonal and annual) temperature or rainfall from the UK Met Office. Sunshine duration is also available.

* `GetDataNRFA()`: Extracts National River Flow Archive data (daily mean flow or catchment rainfall, AMAX, POT, gaugings and metadata).

* `GetDataSEPA()`: Extracts flow, level, or rain data from the Scottish Environment Protection Agency.

There are examples for all of these within each function's help file.

## QMED

The `GetQMED()` function can be used to import the QMED data from the `PeakFlowData` data frame (derived from AMAX data). If it is not in that data frame, it automatically imports the AMAX data using the `GetAM()` function and calculates the median. 

---
title: "Troubleshooting common errors"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Troubleshooting common errors}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

This vignette will be updated as common issues arise.
If you encounter a problem, please open a GitHub issue at <https://github.com/agqhammond/UKFE/issues>.
Confirmed issues will be documented here together with reproducible examples and solutions.

---
title: "ReFH analysis"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{ReFH analysis}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

## The `ReFH()` function
This quick guide provides an overview of how to generate a design hydrograph using the ReFH method. It is assumed that the reader has knowledge of the theory of the ReFH method; this guide is intended to demonstrate how to use the UKFE package rather than to explain the method.

The `ReFH()` function is designed for flexibility and each parameter of the model, along with the inputs and initial conditions, can be user-defined. By default, when catchment descriptors are provided, the ReFH function uses these descriptors to estimate the parameters of the ReFH model, and an estimate of the two-year rainfall for the critical duration (the two year rainfall is approximated from the RMED catchment descriptors). When catchment descriptors are applied, individual parameters and settings can still be adjusted by the user and these adjustments override the estimates from the catchment descriptors. Further details can be found in the function's help file. 

This function applies the ReFH model as specified by Kjeldsen (2007). The ReFH model has since been updated to address some of the limitations. The updated version(s), known as ReFH2, was developed by Wallingford Hydro Solutions (2019) and is available for a licence fee. Henceforth, the original model is denoted ReFH1, and the term 'ReFH' is used when the comment applies to the original and updated versions.

The ReFH outputs are commonly used only to derive a reasonable hydrograph shape. This shape is then scaled to match the peak flow estimate derived using other methods (usually FEH statistical methods). An example of doing this with the function is provided below. There is no automated way of doing so within the function but ReFH parameters can be calibrated using observed rainfall and data to replicate storm events. 

Assumptions and limitations of the ReFH1 model are provided at the bottom after the example of how to derive a design hydrograph.


## Derive a design hydrograph using the ReFH method

In the following example, the ReFH() function is used to derive a design hydrograph, i.e., a hydrograph shape scaled to our design flood estimate (assuming the site to be ungauged). The default use of ReFH() with the catchment descriptors provides the rainfall-runoff outputs for an estimate of the two-year design rainfall event:

```{r setup}
library(UKFE)
```

```{r fig.alt="Runoff hydrograph showing rainfall inputs and resulting flow components. The x-axis shows time in hours. The left y-axis shows discharge, and the right y-axis shows rainfall in millimetres. Rainfall is shown as inverted filled blue bars along the top of the plot, and net rainfall as inverted green striped bars; rainfall is consistently greater than net rainfall, both rising and peaking around 15 hours. Flow is shown as lines: total flow in solid black, baseflow in short dashed green, and direct runoff in dashed red. Total flow and direct runoff peak later than rainfall, with sharp peaks at around 30 hours, while baseflow lags further and peaks more broadly at about 47 hours. The total flow reaches the highest magnitude, followed by direct runoff, with baseflow peaking at much lower levels in a flatter, wider shape."}
# Obtain catchment descriptors for NRFA gauge 55002
CDs.55002 <- GetCDs(55002)

# Obtain outputs of the ReFH model from catchment descriptors for a default 2-year 
# rainfall event
ReFHResult55002 <- ReFH(CDs.55002)
# print to console
ReFHResult55002
```

The output that is printed to the console is a list with two elements. The first element is a data frame of parameters, settings, initial conditions, the catchment area, and peakflow. The second is a data frame with the following columns: Time, Rain, NetRain, Runoff, Baseflow and TotalFlow. A runoff hydrograph plot is also produced.

## Scaled ReFH hydrograph
To scale the hydrograph to the design flow estimate, the results from the ungauged pooling can be used (assuming this is for the ungauged case). We can use the estimate from the FEH statistical analysis vignette:

```{r}
# Create an ungauged pooling group for site 55002 
PoolUG.55002 <- Pool(CDs.55002, exclude = 55002)

# Estimate QMED for site 55002 using catchment descriptors and two donor gauges
CDsQmed.55002 <- QMED(CDs.55002, DonorIDs = c(55007, 55016))

# Estimate design flows using the above pooling group and QMED
Results55002 <- PoolEst(PoolUG.55002, QMED = CDsQmed.55002, CDs = CDs.55002)
```

The results are in the form of a list. The first element provides the return levels, and the 100-year flow estimate is in the 8th row in the second column. We'll make it an object and use it to scale the hydrograph:

```{r fig.alt="Design hydrograph scaled to the estimated peak flow, illustrating the typical storm response. The x-axis is an index of time steps (hours in this case). The hydrograph follows the classic shape, rising steeply to a peak at about 32 hours, then receding more gradually with an elongated, tapering descent. This provides a standardised representation of flow behaviour during a peak event."}
# Extract the 100-year flow estimate (the [[1]] denotes the first element of the list - which is a dataframe, then [8,2] is the 8th row and 2nd column of that dataframe)
Q100.55002 <- Results55002[[1]][8, 2]

# Obtain the final flow outputs of the ReFH model from catchment descriptors for a default 2-year 
# rainfall
TotalFlow <- ReFHResult55002[[2]]$TotalFlow

#Scale this by dividing by the maximum of the flow
ScaledFlow <- TotalFlow / max(TotalFlow)

#Multiply the scaled flow by our peak flow estimate and plot
plot(ScaledFlow * Q100.55002, type = "l", lwd = 2, ylab = "Discharge (m3/s)", xlab = "Time (hours)")

```


## Exporting results
For use outside of 'R', these outputs can be saved as objects and then written to CSV files:

```{r, eval = FALSE}
# Save the ReFH design hydrograph to an object called 'DesignHydro55002'.
DesignHydro55002 <- ScaledFlow * Q100.55002

# Write to csv
write.csv(DesignHydro55002, "my/file/path/DesHydro55002.csv", row.names = FALSE)

```

Note in these examples that `row.names = FALSE` in the `write.csv()` function: our data has no row names, so this prevents an index column being added to the CSV.


## ReFH function as a flexible design rainfall funoff tool

By default this ReFH function is the orginal ReFH model as described by Kjeldsen (2007). Also by default the Flood Studies Report (FSR) rainfall profiles are applied. However, it has many options, including the ability to provide rainfall or choose a randomised profile. Furthermore, the main components can be adjusted such as the unit hydrograph shape, the baseflow, and the loss. For example, if you set UHShape = "FSR", BR = 0, and Loss = 0.5 (or some other proportion), the FSR/FEH design rainfall runoff model is the result. You can also  set UrbanLoss = TRUE, and the urban loss model as used in the ReFH2.3 software is applied.

```{r fig.alt="ReFH output with settings adjusted to result in the FSR/FEH rainfall runoff model. The baseflow is constant and the shape is less elongated than the default ReFH output which uses a kinked triangle unit hydrograph. The rainfall profile is randomised but centrally loaded."}
ReFH.FSR <- ReFH(CDs.55002, RainProfile = "Centre", UHShape = "FSR", Loss = 0.3, BR = 0)
```

## ReFH overview, assumptions and limitations

The ReFH model has three components that conceptualise the catchment process.

Model structure:

1.	A loss model to account for hydrological processes such as evaporation, soil moisture storage, groundwater recharge and interception losses. 
2.	A unit hydrograph-based routing model to distribute the net rainwater over time at the catchment outlet (runoff).
3.	A baseflow model which determines the proportion of the runoff which becomes baseflow recharge and specifies the exponential decay of the river flow once the net rainfall has been routed through the catchment outlet.

### Loss model
The loss model quantifies, for each timestep of rainfall, the proportion of the rain that is effective (the rain that forms the runoff hydrograph). It does so by assuming a maximum catchment soil moisture capacity in mm (Cmax) and an initial catchment soil moisture content in mm (Cini). The original ReFH report (Kjeldsen, 2007) suggests that the Cini / Cmax (Cini divided by Cmax) can be conceptualised as the initial proportion of the catchment that is saturated, and the initial rainfall on this saturated area will form the storm hydrograph. It is assumed that the proportion of rain becoming effective is the same as this saturated proportion.

As rainfall is added, catchment soil moisture increases and Cini / Cmax becomes Ct / Cmax, i.e. the soil moisture for the given timestep divided by the Cmax is the proportion of rain for each timestep which becomes effective.

### Runoff routing model (unit hydrograph)
The unit hydrograph (UH) model is a well-established method for routing effective rainfall to the catchment outlet (Sherman, 1932). There are a number of assumptions:

1.	There is a direct proportional relationship between the effective rainfall and the surface runoff.
2.	The property of superposition. That is, if two successive amounts of effective rainfall, then the surface runoff is the sum of the two associated unit hydrographs (the second one being ahead by one timestep).  
3.	The UH does not change over time. 
4.	The UH shape is the same for all catchments. Only the time to peak and the associated base of the UH changes between catchments.
5.	The catchment rainfall is spatially homogeneous.
6.	The rainfall in a given timestep has a constant intensity.

### Baseflow model
The baseflow model assumes that the saturated area of the catchment that produces surface runoff is the same area that also produces the baseflow recharge. The assumption is that the ratio of recharge to runoff is fixed (the BR parameter). A further parameter, baseflow lag (BL), ensures that the resulting baseflow hydrograph is lagged behind that of the runoff hydrograph (effectively providing a slow flow component). However, this baseflow model does not consider the volume of rainfall directly in the same way the unit hydrograph component does. The resulting baseflow hydrograph is in addition to the runoff hydrograph volume and is calculated as a proportion of it. This means that the volume of the total hydrograph minus initial baseflow is greater than the net/effective rainfall. For the most part, this is not a significant problem because it is assumed that some of the remaining volume of the rainfall makes up the difference. However, if the proportion of effective rainfall is closer to one, the volume of the hydrograph can be greater than the gross/total input of rainfall. This will almost certainly not happen unless the event duration is considerably longer than recommended and only in catchments with a high initial proportion of saturation (due to low BFIHOST and high PROPWET). However, this ReFH function has a WaterBalance argument and setting it to TRUE means that the water balance cannot be invalidated because BR is capped such that BR = (1/NetProp)-1, NetProp is the proportion of effective rainfall. 

## Use cases for the `ReFH()` function

There are three primary use cases:

1.	A flexible tool to model the catchment response to event rainfall. 
2.	A tool for estimating the T-year flow as a function of the T-year rainfall.
3.	To develop a plausible hydrograph shape for scaling to peak flow estimates (usually for the purposes of developing a model boundary).

---
title: "References"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{References}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

FAULKNER, D.S., 1999. *Rainfall frequency estimation (Flood Estimation Handbook volume 2)*. Wallingford: Centre for Ecology and Hydrology. 

HAMMOND, A., 2019. Proposal of the ‘extreme rank plot’ for extreme value 
analysis: with an emphasis on flood frequency studies. *Hydrology Research*, 
50 (6), 1495–1507.

HAMMOND, A., 2021. Sampling uncertainty of UK design flood estimation. Hydrology Research, Vol 52(6), p357–1371. 

HECHT, M. and ZITZMANN, S., 2025. *nonstat: Detecting Nonstationarity in Time Series*. R package version 0.0.6.

HOSKING, J.R.M. AND WALLIS, J.R., 1997. 
*Regional frequency analysis: an approach based on L-moments*. 
Cambridge: Cambridge University Press.

KJELDSEN, T.R., 2007. 
*Flood Estimation Handbook. Supplementary report no.1: The revitalised FSR/FEH rainfall-runoff method*. 
Wallingford: Centre for Ecology & Hydrology.

KJELDSEN, T.R., JONES, D.A., BAYLISS, A.C., 2008. 
*Improving the FEH statistical procedures for flood frequency estimation*. 
Wallingford: Centre for Ecology & Hydrology. Report no. SC050050.

ROBSON, A.J. and REED, D.W., 1999. *Statistical procedures for flood frequency estimation (Flood Estimation Handbook volume 3)*. Wallingford: Centre for Ecology and Hydrology. 

SHERMAN, L. K., 1932. Streamflow from rainfall by unit-graph method. 
*Engineering News Record*, 108:501-505.

WALLINGFORD HYDROSOLUTIONS, (2019). *The Revitalised Flood Hydrograph Model. ReFH2.3: Technical Guide*. Available at: https://refhdocs.hydrosolutions.co.uk/The-ReFH2-Model/Introduction/ [Accessed 22 September 2025].
